﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using DB.Util;

namespace DB.BIZ
{
    class DBDelegate<T>
    {
        public delegate T OpenTranscation(TsqlCommand tsql, SqlConnection conn, SqlTransaction tran);


        public T Open(string strConn, TsqlCommand tsql, OpenTranscation action)
        {
            T t = default(T);
            using (SqlConnection conn = new SqlConnection(strConn))
            {
                conn.Open();
                SqlTransaction tran = conn.BeginTransaction();//开启一个事物

                try
                {

                    t = action(tsql, conn, tran);

                    tran.Commit();
                }
                catch (Exception ex)
                {
                    tran.Rollback();
                    throw ex;
                }
                finally
                {
                    tran.Dispose();
                    conn.Close();
                }
            }
            return t;
        }

    }
}
