﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Data.SqlClient;
using System.Data;

using DB.Util;
using DB.Entity;
using Logic.Entity;
using DB.DAO;


namespace DB.BIZ
{
    public class StudentBIZ
    {

        DBSchool db = new DBSchool();
        StudentDAO dal = new StudentDAO();

        public LeStudent GetStudenById(int id)
        {

            LeStudent student = null;
            using (SqlConnection conn = new SqlConnection(db.GetConnection()))
            {
                conn.Open();
                SqlTransaction tran = conn.BeginTransaction();//开启一个事物

                try
                {

                    TsqlCommand tsql = dal.GetByID(id);
                    SqlCommand command = tsql.CreateCommand(conn, tran);
                    Student stu = SqlModelHelper<Student>.GetSingleObjectBySql(command);

                    student = new LeStudent();
                    student.ID = stu.ID;
                    student.Name = stu.Name;


                    tran.Commit();
                }
                catch (Exception ex)
                {
                    tran.Rollback();
                    throw ex;
                }
                finally
                {
                    tran.Dispose();
                    conn.Close();
                }
            }
            return student;
        }



        public bool DeleteStudentById(int id)
        {
            bool result = false;
            using (SqlConnection conn = new SqlConnection(db.GetConnection()))
            {
                conn.Open();
                SqlTransaction tran = conn.BeginTransaction();//开启一个事物

                try
                {
                    TsqlCommand tsql = dal.Delete(id);
                    SqlCommand command = tsql.CreateCommand(conn, tran);
                    int rowCount = command.ExecuteNonQuery();
                    result = (rowCount > 0);
                    tran.Commit();
                }
                catch (Exception ex)
                {
                    tran.Rollback();
                    throw ex;
                }
                finally
                {
                    tran.Dispose();
                    conn.Close();
                }
            }
            return result;
        }



        public bool DeleteStudentById2(int id)
        {
            bool result = false;
            DBDelegate<int> dele = new DBDelegate<int>();
            int rowCount = dele.Open(db.GetConnection(), dal.Delete(id),Delete);

            result = (rowCount > 0);
            return result;
        }

        int Delete(TsqlCommand tsql, SqlConnection conn, SqlTransaction tran)
        {
            SqlCommand command = tsql.CreateCommand(conn, tran);
            int rowCount = command.ExecuteNonQuery();
            return rowCount;
        }

        public LeStudent GetStudenById2(int id)
        {
            LeStudent student = null;
            DBDelegate<Student> dele = new DBDelegate<Student>();

            Student stu = dele.Open(db.GetConnection(), dal.GetByID(id), GetModel);

            student = new LeStudent();
            student.ID = stu.ID;
            student.Name = stu.Name;
            return student;
        }

        Student GetModel(TsqlCommand tsql, SqlConnection conn, SqlTransaction tran)
        {
            SqlCommand command = tsql.CreateCommand(conn, tran);
            Student stu = SqlModelHelper<Student>.GetSingleObjectBySql(command);
            return stu;
        }

    }
}
