﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;

namespace DB.BIZ
{

    public class TsqlDelegate
    {

        // 定义委托
        public delegate void SqlDelegate();
        public event SqlDelegate StartConnPool;

        public void StartConnection(string strConn)
        {
            using (SqlConnection conn = new SqlConnection(strConn))
            {
                conn.Open();
                SqlTransaction tran = conn.BeginTransaction();//开启一个事物

                try
                {
                    if (StartConnPool != null)
                    {
                        StartConnPool();
                    }

                }
                catch (Exception ex)
                {
                    tran.Rollback();
                    throw ex;
                }
                finally
                {
                    tran.Dispose();
                    conn.Close();
                }
                return;
            }
        }
    }
}
