﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


using DB.Util;


namespace DB.DAO
{
    public interface IEntity<T>
    {

        /// <summary>
        /// 添加一个对象
        /// </summary>
        /// <param name="entity">要添加的对象</param>
        /// <returns>添加后的主键</returns>
        TsqlCommand Insert(T entity);

        /// <summary>
        /// 修改一个对象
        /// </summary>
        /// <param name="entity">要修改的须向</param>
        /// <returns></returns>
        TsqlCommand Update(T entity);

        /// <summary>
        /// 删除一个对象
        /// </summary>
        /// <param name="ID"></param>
        /// <returns></returns>
        TsqlCommand Delete(object ID);

        /// <summary>
        /// 通过主键获取一个对象
        /// </summary>
        /// <param name="ID">主键ID</param>
        /// <returns>查询出来的结果</returns>
        TsqlCommand GetByID(object ID);

        /// <summary>
        /// 获得所有对象列表
        /// </summary>
        /// <returns></returns>
        TsqlCommand GetList();


        /// <summary>
        /// 通过分页获得所有的对象列表
        /// 不适用于 夺标联合查询的分页，包括条件已经返回值
        /// </summary>
        /// <param name="condition"></param>
        /// <returns></returns>
        TsqlCommand GetListByPaging(PagingCondtion<T> condition);

        /// <summary>
        /// 批量删除一个对象
        /// </summary>
        /// <param name="ids">封装的主键值数组</param>
        TsqlCommand DeleteByIds(string[] ids);

    }
}
