﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DB.Util;


namespace DB.DAO
{
    public class PagingCondtion<T>
    {

        public PagingCondtion() { }

        public PagingCondtion(T entity)
        {
            _entity = entity;
        }

        private T _entity;

        private int _pageIndex;

        private int _pageSize;

        private int _recordCount;

        private Nullable<DateTime> _startDate;

        private Nullable<DateTime> _endDate;

        private List<TsqlParameter> _otherCondition = new List<TsqlParameter>();

        /// <summary>
        /// 其他条件
        /// </summary>
        public List<TsqlParameter> OtherCondition
        {
            get { return _otherCondition; }
            set { _otherCondition = value; }
        }

        /// <summary>
        /// 结束时间，为null则在解析时不进行条件添加
        /// 针对于单一的一个结束时间，
        /// 如果存在多个结束时间需要传递值的时候，可以考虑使用OtherCondition 进行封装
        /// </summary>
        public Nullable<DateTime> EndDate
        {
            get { return _endDate; }
            set { _endDate = value; }
        }

        /// <summary>
        /// 开始时间，为null则不进行条件添加
        /// 针对于单一的一个开始时间，
        /// 如果存在多个开始时间需要传递值的时候，可以考虑使用OtherCondition 进行封装
        /// </summary>
        public Nullable<DateTime> StartDate
        {
            get { return _startDate; }
            set { _startDate = value; }
        }

        /// <summary>
        /// 要返回的记录值
        /// </summary>
        public int RecordCount
        {
            get { return _recordCount; }
            set { _recordCount = value; }
        }



        /// <summary>
        /// 每一页分页的大小
        /// </summary>
        public int PageSize
        {
            get { return _pageSize; }
            set { _pageSize = value; }
        }

        /// <summary>
        /// 该页的页码，从1开始，不是从0开始
        /// </summary>
        public int PageIndex
        {
            get { return _pageIndex; }
            set { _pageIndex = value; }
        }

        /// <summary>
        /// 该对象，用于 各种条件封装
        /// </summary>
        public T Entity
        {
            get { return _entity; }
            set { _entity = value; }
        }

    }





}
