﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;

namespace DB.ORM
{
    [AttributeUsage(AttributeTargets.Property | AttributeTargets.Field, AllowMultiple = false)]
    public sealed class ModelsAttribute : System.Attribute
    {
        /// <summary>
        /// 数据库中定义长度
        /// int 类型需要给值4 
        /// </summary>
        public int Length { set; get; }

        /// <summary>
        /// 是否主键
        /// 默认是false
        /// </summary>
        public bool IsPrimary { get; set; }

        /// <summary>
        /// 是否是自增长列
        /// 默认是false
        /// </summary>
        public bool IsIdentity { set; get; }

        /// <summary>
        /// 默认值
        /// </summary>
        public object Default { set; get; }


        /// <summary>
        /// 数据类型
        /// </summary>
        public SqlDbType DbType { set; get; }


    }
}
