﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;

namespace DB.Util
{
    /// <summary>
    /// 针对SQLServer查询返回模型的辅助类
    /// </summary>
    public class SqlModelHelper<T> where T : class ,new()
    {

        /// <summary>
        /// 根据Sql获得单个对象
        /// </summary>
        /// <param name="sql">SQL语句</param>
        /// <param name="pas">参数数组</param>
        /// <returns>单个对象</returns>
        public static T GetSingleObjectBySql(SqlCommand command)
        {
            DataTable dt = DBHelper.ExecuteDataTable(command);
            IList<T> ts = ModelConvertHelper<T>.ConvertToModel(dt);
            return (ts.Count == 0 ? null : ts[0]);
        }

        /// <summary>
        /// 根据Sql获得某对象的集合
        /// </summary>
        /// <param name="sql">SQL语句</param>
        /// <param name="pas">参数数组</param>
        /// <returns>对象集合</returns>
        public static IList<T> GetObjectsBySql(SqlCommand command)
        {
            DataTable dt = DBHelper.ExecuteDataTable(command);
            return ModelConvertHelper<T>.ConvertToModel(dt);
        }

    }
}
