﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using System.Data;

namespace DB.Util
{
    public class TsqlCommand
    {



        //执行语句
        private string _tsqlText;

        public string TsqlText
        {
            get { return _tsqlText; }
            set { _tsqlText = value; }
        }


        private List<SqlParameter> _parameters = new List<SqlParameter>();

        public List<SqlParameter> Parameters
        {
            get { return _parameters; }
            set { _parameters = value; }
        }

        private CommandType type = CommandType.Text;

        public CommandType Type
        {
            get { return type; }
            set { type = value; }
        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="conn"></param>
        /// <param name="tran"></param>
        /// <returns></returns>
        public SqlCommand CreateCommand(SqlConnection conn, SqlTransaction tran)
        {
            SqlCommand command = new SqlCommand(_tsqlText, conn, tran);
            if (_parameters.Count > 0)
            {
                DealSqlParameter(conn, tran, command, _parameters.ToArray());
            }
            else
            {
                DealSqlParameter(conn, tran, command);
            }

            command.CommandType = type;
            return command;
        }


        /// <summary>
        /// 处理 自身写的链接方式没有处理参数的DBNull类型的方法
        /// </summary>
        /// <param name="command"></param>
        /// <param name="pas"></param>
        private void DealSqlParameter(SqlConnection conn, SqlTransaction tran, SqlCommand command, params SqlParameter[] pas)
        {
            command.Connection = conn;
            command.Transaction = tran;

            foreach (SqlParameter parameter in pas)
            {
                if ((parameter.Direction == ParameterDirection.InputOutput || parameter.Direction == ParameterDirection.Input) &&
                        (parameter.Value == null))
                {
                    parameter.Value = DBNull.Value;
                }
                command.Parameters.Add(parameter);
            }
        }



    }
}
